<?php
/*
= LuxCal event calendar index =

 Copyright 2009-2011  LuxSoft - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.
*/

if (!file_exists("config.php")) { header("Location: install.php"); exit(); }

//set error reporting
error_reporting(E_ALL ^ E_NOTICE); //errors, no notices
//error_reporting(E_ALL); //errors and notices - test line
ini_set('display_errors',0);
 
//Current LuxCal version / maintenance suffix
define("LCV","2.4.2"); define("LCM","");

//proxies: don't cache
header("Cache-control: private");

//start session
session_set_cookie_params(2500000); //expire in 1 month
session_start();
if (!isset($_SESSION['lastTime']) or $_SESSION['lastTime'] + 900 < time()) { //if last visit > 15 mins ago
	unset($_SESSION['cD'], $_SESSION['cC']); //reset date and cat
}
$_SESSION['lastTime'] = time();

//get config and tools
require './config.php';
require './common/toolbox.php';

//set time zone
date_default_timezone_set($timeZone);

//establish database connection
$link = mysql_connect($hn, $un, $pw) or die ("Could not connect to database, check database credentials in config.php");
if (!mysql_select_db($db,$link)) die ("Could not select database $db");
//mysql_set_charset('utf8',$link); //support non-Latin char sets

//run upgrade if config.php not current
if (!defined('LCC') or LCC < LCV) { require './upgrade'.str_replace('.','',LCV).'.php'; }

//check for mobile browsers
$mobile = isMobile();

//get user data & set privs
if (empty($_SESSION['uid'])) { $_SESSION['uid'] = 1; } //public user
while (true) {
	$result = dbquery("SELECT user_name, sedit, privs, language FROM [db]users WHERE user_id = {$_SESSION['uid']}");
	if ($row = mysql_fetch_assoc($result)) { // user id found
		$uname = $row["user_name"];
		$privs = $row["privs"];
		$sedit = ($row["sedit"]) ? 1 : 0;
		break;
	} else {
		$_SESSION['uid'] = 1; //public user
	}
}

//set language
if (isset($_REQUEST["cL"])) { $_SESSION['cL'] = $_REQUEST["cL"]; }
elseif (empty($_SESSION['cL'])) { $_SESSION['cL'] = $language; }
if (!file_exists('lang/ui-'.strtolower($_SESSION['cL']).'.php')) { $_SESSION['cL'] = "English"; }
require './lang/ui-'.strtolower($_SESSION['cL']).'.php';

if ($_SESSION['uid'] == 1) { $uname = $xx["idx_public_name"]; }

//page definitions
$pages = array (
	 "1" => array ("views/year.php", "", "L", ""), //page, special attributes (in PHP fomat), header size, page title
	 "2" => array ("views/month.php", "", "L", ""),
	 "3" => array ("views/week.php", "", "L", ""),
	 "4" => array ("views/day.php", "", "L", ""),
	 "5" => array ("views/upcoming.php", "", "L", $xx["title_upcoming"]),
	 "6" => array ("views/changes.php", "", "L", $xx["title_changes"]),

	"10" => array ("pages/event.php", '$_REQUEST["mode"] = "add";', "S", $xx["title_add_event"]),
	"11" => array ("pages/event.php", '$_REQUEST["mode"] = "show";', "S", $xx["title_event_details"]),
	"12" => array ("pages/event.php", '$_REQUEST["mode"] = "edit";', "S", $xx["title_edit_event"]),
	"13" => array ("pages/event.php", '$_REQUEST["mode"] = "showMini";', "S", $xx["title_event_details"]),

	"20" => array ("pages/login.php", "", "L", ""),
	"21" => array ("lang/ug-".strtolower($_SESSION['cL']).".php", "", "S", $xx["title_user_guide"]),

	"90" => array ("pages/settings.php", "", "L", $xx["title_settings"]),
	"91" => array ("pages/categories.php", "", "L", $xx["title_edit_cats"]),
	"92" => array ("pages/users.php", "", "L", $xx["title_edit_users"]),
	"93" => array ("pages/database.php", "", "L", $xx["title_manage_db"]),
	"94" => array ("pages/importICS.php", "", "L", $xx["title_ics_import"]),
	"95" => array ("pages/exportICS.php", "", "L", $xx["title_ics_export"]),
	"96" => array ("pages/importCSV.php", "", "L", $xx["title_csv_import"])
);

//set header (nav bar) display
if (isset($_REQUEST['hdr'])) { $_SESSION['hdr'] = $_REQUEST['hdr']; }
elseif (!isset($_SESSION['hdr'])) { $_SESSION['hdr'] = 1; }

//set current page
if (isset($_REQUEST['cP'])) { $_SESSION['cP'] = $_REQUEST['cP']; }
if (empty($_SESSION['cP'])) { $_SESSION['cP'] = $defaultView; }
elseif (!array_key_exists($_SESSION['cP'], $pages) or $pages[$_SESSION['cP']][2] == "S") { $_SESSION['cP'] = $defaultView; }
$cP = (isset($_REQUEST['xP'])) ? $_REQUEST['xP'] : $_SESSION['cP']; //$xP: extra page in separate window

//set current date
if (isset($_REQUEST['newD'])) { $_SESSION['cD'] = DDtoID($_REQUEST['newD']); }
elseif (isset($_REQUEST['cD'])) { $_SESSION['cD'] = $_REQUEST['cD']; }
elseif (empty($_SESSION['cD'])) { $_SESSION['cD'] = date("Y-m-d"); }

//set category filter
if (isset($_REQUEST['cC'])) { $_SESSION['cC'] = $_REQUEST['cC']; }
elseif (!isset($_SESSION['cC'])) { $_SESSION['cC'] = 0; }

//if no access, login required
if (!$privs) {
	$cP = 20; //log in
	$msg = $xx["idx_log_in"];
}

eval($pages[$cP][1]); //special attributes
$pageTitle = $pages[$cP][3];

//select page header
if ($pages[$cP][2] != 'S') {
	require './common/retrieve.php';
	if ($_SESSION['hdr'] == 0) {
		require './canvas/header_xs.php';
	} else {
		require './canvas/header.php';
	}
} else {
	require './canvas/header_s.php';
}
require './'.$pages[$cP][0];
if ($pages[$cP][2] != 'S' and !$mobile) {
	require './canvas/footer.php';
} else {
	require './canvas/footer_s.php';
}
?>
